- run createrepo with the correct -g option
[bootcd.git] / build.sh
index 03aaa18..194c747 100755 (executable)
--- a/build.sh
+++ b/build.sh
@@ -8,9 +8,10 @@ CONFIGURATIONS_DIR=configurations/
 # where built files are stored
 BUILD_DIR=build/
 
-BOOTCD_VERSION="3.0-beta0.4"
-FULL_VERSION_STRING="PlanetLab BootCD $BOOTCD_VERSION"
-
+BOOTCD_VERSION="3.3"
+FULL_VERSION_STRING="PlanetLab BootCD"
+OUTPUT_IMAGE_NAME='PlanetLab-BootCD'
+    
 SYSLINUX_SRC=sources/syslinux-2.11.tar.bz2
 
 BOOTCD_YUM_GROUP=BootCD
@@ -26,6 +27,19 @@ RAMDISK_SIZE=64
 INITRD_BYTES_PER_INODE=1024
 
 
+# make sure the boot manager source is checked out in the same directory
+# as the bootcd_v3 repository
+for BOOTMANAGER_DIR in ../bootmanager-* ../bootmanager ; do
+    [ -d $BOOTMANAGER_DIR ] && break
+done
+
+if [ ! -d $BOOTMANAGER_DIR ]; then
+    echo "the bootmanager repository needs to be checked out at the same"
+    echo "level as this directory, for the merge_hw_tables.py script"
+    exit
+fi
+
+
 function usage()
 {
     echo "Usage: build.sh <action> [<configuration>]"
@@ -56,20 +70,71 @@ function build_cdroot()
     echo "setup rpm to install only en_US locale and no docs"
     mkdir -p $CD_ROOT/etc/rpm
     cp -f $CONF_FILES_DIR/macros $CD_ROOT/etc/rpm
+    # trick rpm and yum
+    export HOME=$PWD
+    cp -f $CONF_FILES_DIR/macros $PWD/.rpmmacros
 
     echo "initialize rpm db"
     mkdir -p $CD_ROOT/var/lib/rpm
     rpm --root $CD_ROOT --initdb
+    
+    # XXX Should download yum.conf from the boot server?
+    echo "generate yum.conf"
+cat >yum.conf <<EOF
+[main]
+cachedir=/var/cache/yum
+debuglevel=2
+logfile=/var/log/yum.log
+pkgpolicy=newest
+### for yum-2.4 in fc4 (this will be ignored by yum-2.0)
+### everything in here, do not scan /etc/yum.repos.d/
+reposdir=/dev/null
+
+[FedoraCore2Base]
+name=Fedora Core 2 Base -- PlanetLab Central
+baseurl=http://$PRIMARY_SERVER/install-rpms/stock-fc2/
+
+[FedoraCore2Updates]
+name=Fedora Core 2 Updates -- PlanetLab Central
+baseurl=http://$PRIMARY_SERVER/install-rpms/updates-fc2/
+
+[PlanetLab]
+name=PlanetLab RPMS -- PlanetLab Central
+baseurl=http://$PRIMARY_SERVER/install-rpms/planetlab-rollout/
+EOF
+    # XXX Temporary hack until the 3.2 rollout is complete and the
+    # /planetlab/yumgroups.xml file contains the BootCD group.
+    yumgroups="http://$PRIMARY_SERVER/install-rpms/planetlab-rollout/yumgroups.xml"
+
+   # Solve the bootstrap problem by including any just built packages in
+   # the yum configuration. This cooperates with the PlanetLab build
+   # system.
+   if [ -n "$RPM_BUILD_DIR" ] ; then
+       yum-arch $(dirname $RPM_BUILD_DIR)/RPMS
+       createrepo -g yumgroups.xml $(dirname $RPM_BUILD_DIR)/RPMS || :
+       # If run under sudo, allow user to delete the headers/ and
+       # repodata/ directories.
+       if [ -n "$SUDO_USER" ] ; then
+          chown -R $SUDO_USER $(dirname $RPM_BUILD_DIR)/RPMS
+       fi
+       cat >>yum.conf <<EOF
+[Bootstrap]
+name=Bootstrap RPMS -- $(dirname $RPM_BUILD_DIR)/RPMS/
+baseurl=file://$(dirname $RPM_BUILD_DIR)/RPMS/
+EOF
+       yumgroups="file://$(dirname $RPM_BUILD_DIR)/RPMS/yumgroups.xml"
+   fi
 
     echo "install boot cd base rpms"
     yum -c yum.conf --installroot=$CD_ROOT -y groupinstall $BOOTCD_YUM_GROUP
 
+    # Retrieve all of the packagereq declarations in the BootCD group of the yumgroups.xml file
     echo "checking to make sure rpms were installed"
-    packages=`cat yumgroups.xml | grep packagereq | sed 's#<[^<]*>##g'`
+    packages=$(curl $yumgroups | sed -n -e '/<name>BootCD<\/name>/,/<name>/{ s/.*<packagereq.*>\(.*\)<\/packagereq>/\1/p }')
     set +e
     for package in $packages; do
        echo "checking for package $package"
-       chroot $CD_ROOT /bin/rpm -qi $package > /dev/null
+       /usr/sbin/chroot $CD_ROOT /bin/rpm -qi $package > /dev/null
        if [[ "$?" -ne 0 ]]; then
            echo "package $package was not installed in the cd root."
            echo "make sure it exists in the yum repository."
@@ -84,7 +149,7 @@ function build_cdroot()
 
     echo "setting up non-ssh authentication"
     mkdir -p $CD_ROOT/etc/samba
-    chroot $CD_ROOT /usr/sbin/authconfig --nostart --kickstart \
+    /usr/sbin/chroot $CD_ROOT /usr/sbin/authconfig --nostart --kickstart \
        --enablemd5 --enableshadow
 
     echo "setting root password"
@@ -97,6 +162,12 @@ function build_cdroot()
     mv $CD_ROOT/var/lib/rpm $CD_ROOT/usr/relocated/var/lib/
     (cd $CD_ROOT/var/lib && ln -s ../../usr/relocated/var/lib/rpm rpm)
 
+    # get /var/cache/yum out, its 100Mb. create in its place a 
+    # symbolic link to /usr/relocated/var/cache/yum
+    mkdir -p $CD_ROOT/usr/relocated/var/cache/
+    mv $CD_ROOT/var/cache/yum $CD_ROOT/usr/relocated/var/cache/
+    (cd $CD_ROOT/var/cache && ln -s ../../usr/relocated/var/cache/yum yum)
+
     # get /lib/tls out
     mkdir -p $CD_ROOT/usr/relocated/lib
     mv $CD_ROOT/lib/tls $CD_ROOT/usr/relocated/lib/
@@ -113,6 +184,10 @@ function build_cdroot()
     KERNEL=$CD_ROOT/boot/vmlinuz-*
     mv -f $KERNEL $CD_ROOT/usr/isolinux/kernel
 
+    echo "moving /usr/bin/find and /usr/bin/dirname to /bin"
+    mv $CD_ROOT/usr/bin/find $CD_ROOT/bin/
+    mv $CD_ROOT/usr/bin/dirname $CD_ROOT/bin/
+
     echo "creating version files"
     echo "$FULL_VERSION_STRING" > $CD_ROOT/usr/isolinux/pl_version
     echo "$FULL_VERSION_STRING" > $CD_ROOT/pl_version
@@ -120,11 +195,9 @@ function build_cdroot()
     touch $CD_ROOT/.built
 }
 
-function build_initrd()
+function init_initrd()
 {
-    echo "building initrd"
-    rm -f $INITRD
-    rm -f $INITRD.gz
+    echo "initialize configuration files"
 
     echo "copy fstab and mtab"
     cp -f $CONF_FILES_DIR/fstab $CD_ROOT/etc/
@@ -175,11 +248,15 @@ function build_initrd()
     echo "$PRIMARY_SERVER" > $CD_ROOT/usr/bootme/BOOTSERVER_IP
     echo "$PRIMARY_SERVER_PORT" > $CD_ROOT/usr/bootme/BOOTPORT
 
+    echo "copying cacert to old boot cd directory bootme (TEMPORARY)"
+    mkdir -p $CD_ROOT/usr/bootme/cacert/$PRIMARY_SERVER/
+    cp -f $CURRENT_CONFIG_DIR/$PRIMARY_SERVER_CERT \
+       $CD_ROOT/usr/bootme/cacert/$PRIMARY_SERVER/cacert.pem
+
     echo "forcing lvm to make lvm1 partitions (TEMPORARY)"
     cp -f $CONF_FILES_DIR/lvm.conf $CD_ROOT/etc/lvm/
 
     echo "copying isolinux configuration files"
-    cp -f $CONF_FILES_DIR/isolinux.cfg $CD_ROOT/usr/isolinux/
     echo "$FULL_VERSION_STRING" > $CD_ROOT/usr/isolinux/message.txt
 
     echo "writing /etc/issue"
@@ -194,20 +271,41 @@ function build_initrd()
            $CD_ROOT/usr/boot/plnode.txt
     fi
 
-    echo "making the isolinux initrd kernel command line match rd size"
-    let INITRD_SIZE_KB=$(($RAMDISK_SIZE * 1024))
-    sed -i "s#ramdisk_size=0#ramdisk_size=$INITRD_SIZE_KB#g" \
-       $CD_ROOT/usr/isolinux/isolinux.cfg
-
     echo "building pcitable for hardware detection"
     pci_map_file=`find $CD_ROOT/lib/modules/ -name modules.pcimap | head -1`
     module_dep_file=`find $CD_ROOT/lib/modules/ -name modules.dep | head -1`
     pci_table=$CD_ROOT/usr/share/hwdata/pcitable
-    ./scripts/rewrite-pcitable.py $module_dep_file $pci_map_file $pci_table \
-       $CD_ROOT/etc/pl_pcitable
+    $BOOTMANAGER_DIR/source/merge_hw_tables.py \
+       $module_dep_file $pci_map_file $pci_table $CD_ROOT/etc/pl_pcitable
+
+}
+
+function build_initrd()
+{
+    big=$1
+
+    echo "building initrd"
+    rm -f $INITRD
+    rm -f $INITRD.gz
+    rm -f $CD_ROOT/usr/isolinux/initrd
+    rm -f $CD_ROOT/usr/isolinux/initrd.gz
+
+    TOTAL_SIZE=$(du -ksc $CD_ROOT | awk '$2 == "total" { print $1}')
+    if [ $big -eq 1 ]; then
+       let TOTAL_SIZE=$TOTAL_SIZE-$(du -ksc $CD_ROOT/usr/isolinux | awk '$2 == "total" { print $1}')
+    else
+       let TOTAL_SIZE=$TOTAL_SIZE-$(du -ksc $CD_ROOT/usr | awk '$2 == "total" { print $1}')
+    fi
+    let INITRD_SIZE=($TOTAL_SIZE/1024)+$RAMDISK_SIZE+4
 
-    dd if=/dev/zero of=$INITRD bs=1M count=$RAMDISK_SIZE
-    mkfs.ext2 -F -m 0 -i $INITRD_BYTES_PER_INODE $INITRD
+    echo "making the isolinux initrd kernel command line match rd size"
+    let INITRD_SIZE_KB=$(($INITRD_SIZE * 1024))
+    cp -f $CONF_FILES_DIR/isolinux.cfg $CD_ROOT/usr/isolinux/
+    sed -i "s#ramdisk_size=0#ramdisk_size=$INITRD_SIZE_KB#g" \
+       $CD_ROOT/usr/isolinux/isolinux.cfg
+
+    dd if=/dev/zero of=$INITRD bs=1M count=$INITRD_SIZE
+    /sbin/mkfs.ext2 -F -m 0 -i $INITRD_BYTES_PER_INODE $INITRD
     mkdir -p $INITRD_MOUNT
     mount -o loop,rw $INITRD $INITRD_MOUNT
 
@@ -217,11 +315,22 @@ function build_initrd()
     find . -path ./usr -prune -o -print | cpio -p -d -u $INITRD_MOUNT
     popd
 
+    if [ $big -eq 1 ]; then
+       echo "copy usr to ramdisk"
+       pushd .
+       cd $CD_ROOT
+       find ./usr -path ./usr/isolinux -o -print | cpio -p -d -u $INITRD_MOUNT
+       popd
+    fi
+
     umount $INITRD_MOUNT
     rmdir $INITRD_MOUNT
     
+    # INITRD_SIZE=$(`ls -sh $INITRD | awk '{print $1}'`)
+    # echo "initrd size = $INITRD_SIZE"
     echo "compressing ramdisk"
-    gzip $INITRD
+    gzip -9 $INITRD
+    mv -f $INITRD.gz $CD_ROOT/usr/isolinux
 }
 
 function build()
@@ -230,12 +339,60 @@ function build()
     build_cdroot
 
     # always build/rebuild initrd
-    build_initrd
+    init_initrd
+
+    ####################################################################################
+    # build small initrd for small iso and usb image
+    build_initrd 0
 
+    # build iso image
     rm -f $ISO
     mkisofs -o $ISO -R -allow-leading-dots -J -r -b isolinux/isolinux.bin \
        -c isolinux/boot.cat -no-emul-boot -boot-load-size 4 -boot-info-table \
        $CD_ROOT/usr
+
+    # build usb image and make it bootable with syslinux (instead of isolinux)
+    USB_IMAGE=${ISO%*.iso}.usb
+    # leave 1 MB of free space on the filesystem
+    USB_KB=$(du -kc $ISO $CD_ROOT/usr/isolinux | awk '$2 == "total" { print $1 + 1024 }')
+    /sbin/mkfs.vfat -C $USB_IMAGE $USB_KB
+
+    mkdir -p $INITRD_MOUNT
+    mount -o loop,rw $USB_IMAGE $INITRD_MOUNT
+
+    # populate the root of the image with pl_version, and the syslinux files
+    cp -a $ISO $INITRD_MOUNT
+    cp -a $CD_ROOT/usr/isolinux/{initrd.gz,kernel,message.txt,pl_version} $INITRD_MOUNT
+    cp -a $CD_ROOT/usr/isolinux/isolinux.cfg $INITRD_MOUNT/syslinux.cfg
+
+    umount $INITRD_MOUNT
+    rmdir $INITRD_MOUNT
+
+    # make it bootable
+    syslinux $USB_IMAGE
+
+    ####################################################################################
+    # build small initrd for small iso and usb image
+    build_initrd 1
+    
+    # build usb image and make it bootable with syslinux (instead of isolinux)
+    USB_IMAGE=${ISO%*.iso}-biginitrd.usb
+    # leave 1 MB of free space on the filesystem
+    USB_KB=$(du -kc $CD_ROOT/usr/isolinux | awk '$2 == "total" { print $1 + 1024 }')
+    /sbin/mkfs.vfat -C $USB_IMAGE $USB_KB
+
+    mkdir -p $INITRD_MOUNT
+    mount -o loop,rw $USB_IMAGE $INITRD_MOUNT
+
+    # populate the root of the image with pl_version, and the syslinux files
+    cp -a $CD_ROOT/usr/isolinux/{initrd.gz,kernel,message.txt,pl_version} $INITRD_MOUNT
+    cp -a $CD_ROOT/usr/isolinux/isolinux.cfg $INITRD_MOUNT/syslinux.cfg
+
+    umount $INITRD_MOUNT
+    rmdir $INITRD_MOUNT
+
+    # make it bootable
+    syslinux $USB_IMAGE
 }
 
 function burn()
@@ -266,24 +423,37 @@ if [[ "$1" == "clean" || "$1" == "burn" || "$1" == "build" ]]; then
     . $CURRENT_CONFIG_DIR/configuration
 
     # setup vars for this configuration
+
+    # version string for this build
     if [[ ! -z "$EXTRA_VERSION" ]]; then
-       FULL_VERSION_STRING="$FULL_VERSION_STRING-$EXTRA_VERSION"
+       FULL_VERSION_STRING="$FULL_VERSION_STRING $EXTRA_VERSION"
     fi
+    FULL_VERSION_STRING="$FULL_VERSION_STRING $BOOTCD_VERSION"
 
     # destination image
+    if [[ ! -z "$EXTRA_VERSION" ]]; then
+       OUTPUT_IMAGE_NAME="$OUTPUT_IMAGE_NAME-$EXTRA_VERSION"
+    fi
+    OUTPUT_IMAGE_NAME="$OUTPUT_IMAGE_NAME-$BOOTCD_VERSION"
+
+    # setup build directories
     BUILD_DIR=build/$configuration
     mkdir -p $BUILD_DIR
     ISO=$BUILD_DIR/`echo $OUTPUT_IMAGE_NAME | sed -e "s/%version/$BOOTCD_VERSION/"`.iso
 
-    # built cd root
     CD_ROOT=`pwd`/$BUILD_DIR/cdroot
     mkdir -p $CD_ROOT
 
     # location of the uncompressed ramdisk image
-    INITRD=$CD_ROOT/usr/isolinux/initrd
+    INITRD=`pwd`/$BUILD_DIR/initrd
 
     # temporary mount point for rd
-    INITRD_MOUNT=`pwd`/$BUILD_DIR/rd
+    MYPWD=`pwd`
+    INITRD_MOUNT=`mktemp -q -p $MYPWD/$BUILD_DIR -d -t rd.XXXXXXXX`
+    if [ $? -ne 0 ]; then
+       echo "failed to create tempory mount point for initrd"
+       exit 1
+    fi
 
 
     case $action in